-- License CC0 (Creative Commons license) (c) darkfrei, 2023


--love.window.setMode(1280, 800) -- Steam Deck resolution
love.window.setMode(1280*2, 800*2) -- double Steam Deck resolution
Width, Height = love.graphics.getDimensions( )

local tileTransitions6 = {
	{c={1,0,0,0,0,0,0,0}, r=4}, -- top left vertex
	{c={1,1,1,0,0,0,0,0}, r=4}, -- top plank
	{c={1,1,1,1,1,0,0,0}, r=4}, -- top left edge
	{c={1,1,1,1,1,1,1,0}, r=4}, -- right U
	{c={1,1,1,1,1,1,1,1}, r=1}, -- O-tile
	{c={1,1,1,1,1,1,1,1}, r=1}, -- full
	{c={0,0,0,0,0,0,0,0}, r=1}, -- nothing
}
local path = 'graphics/'
local filename = 'tile-02'
local ext = '.png'


------------------ special functtions: -----------------
local function boolToNum (a, b, c, d, e, f, g, h)
  return a + 2*b + 4*c + 8*d + 16*e + 32*f + 64*g + 128*h
end

local function getShiftedSequence (list, r)
	local c = {unpack(list)}
		for j = 1, r do
			-- moving last to the first:
			table.insert (c, 1, table.remove(c, #c))
			table.insert (c, 1, table.remove(c, #c))
		end
	return c
end
------------------ end of  special functtions: -----------------




-- the table of all tiles, use index to get the right one:
local mapUtiles = {}
local emptyTile = {
	image = love.graphics.newImage(path..filename..'-7'..ext),
	c = {0,0,0,0,0,0,0,0},
	r=0,
}
emptyTile.w, emptyTile.h = emptyTile.image:getDimensions()
mapUtiles[256] = emptyTile








for i = 1, 6 do
	local tile = tileTransitions6[i]
--	local canvas = love.graphics.newCanvas(emptyTile.w, emptyTile.h)
	local image = love.graphics.newImage(path..filename..'-'..i..ext)
--	love.graphics.setCanvas(canvas)
--		love.graphics.draw(emptyTile.image)
--		love.graphics.draw(image)
--	love.graphics.setCanvas()
	local rMax = tile and (tile.r-1) or 0
	local c = tile and tile.c or {0,0,0,0,0,0,0,0}
	for r = 0, rMax do
		local c = getShiftedSequence (c, r)
		local uTile = {c=c, image=image, r=r}
		local number = boolToNum (unpack(uTile.c))
		if i == 6 then number = 0 end
		if i == 7 then number = 256 end
		if not (mapUtiles[number]) then
			mapUtiles[number] = uTile
		else
			print (number .. 'exists (1)')
		end
	end
end


-- list of overlappings:
local tr15 = {
	{1, 4},
	{1, 4, 16},
	{1, 4, 16, 64},
	{1+2+4+8+16, 64},
	{1+2+4, 16},
	{1+2+4, 64},
	{1+2+4, 16, 64},
	{1+2+4, 16+32+64},
	{1, 16},
}

for i, numbers in ipairs (tr15) do
	local canvas = love.graphics.newCanvas(emptyTile.w, emptyTile.h)
	local n = 0
	local cNew = {0,0,0,0,0,0,0,0}
	love.graphics.setCanvas(canvas)
--		love.graphics.setBlendMode("alpha")
--		love.graphics.rectangle('fill', 0,0, emptyTile.w, emptyTile.h)
-- draw empty
		love.graphics.setBlendMode("alpha")
--		love.graphics.draw(emptyTile.image, emptyTile.w/2, emptyTile.h/2, 0, 1, 1, emptyTile.w/2, emptyTile.h/2)
--		love.graphics.setBlendMode("multiply", "premultiplied")
--		love.graphics.setBlendMode("alpha")
		for j, number in ipairs (numbers) do
			n = n + number
			local tile = mapUtiles[number]
			love.graphics.draw(tile.image, emptyTile.w/2, emptyTile.h/2, tile.r*math.pi/2, 1, 1, emptyTile.w/2, emptyTile.h/2)
			for k = 1, #tile.c do
				if tile.c[k] == 1 then
					cNew[k] = 1
				end
			end
		end
	love.graphics.setCanvas()
	
	-- adding rotated tiles
	for r = 0, 3 do
		local c = getShiftedSequence (cNew, r)
		local numberNew = boolToNum (unpack(c))
		if not (mapUtiles[numberNew]) then
			local tile = {c=c, image=canvas, r=r}
			mapUtiles[numberNew] = tile
		else
			print (numberNew.. ' exists!')
			break
		end
	end
	love.graphics.setBlendMode("alpha")
end

print ('w', emptyTile.w, 'h', emptyTile.h)
local n_mapUtiles = 0
local numbers = {}
for number, tile in pairs (mapUtiles) do
	n_mapUtiles = n_mapUtiles + 1
	table.insert (numbers, number)
end
print ('n_mapUtiles', n_mapUtiles)



-- works, disabled:
--[[
for number, tile in pairs (mapUtiles) do
	local canvas = love.graphics.newCanvas(emptyTile.w, emptyTile.h)
	love.graphics.setCanvas(canvas)
		love.graphics.draw(tile.image, emptyTile.w/2, emptyTile.h/2, tile.r*math.pi/2, 1, 1, emptyTile.w/2, emptyTile.h/2)
	love.graphics.setCanvas()
	local strNumber = string.format("%03d", number)
	canvas:newImageData():encode("png","tile-"..strNumber..".png")
end
]]

local canvas48 = love.graphics.newCanvas(emptyTile.w*16, emptyTile.h*3)
local spriteTiles48 = {
	{  0,16, 3}, -- full
	{  1,10, 3},
	{  4, 8, 3},
	{  5, 9, 3},
	{  7, 3, 1},
	{ 16, 8, 1},
	{ 17,12, 3},
	{ 20, 8, 2},
	{ 21,11, 2},
	{ 23,15, 1},
	{ 28, 4, 2},
	{ 29,14, 2},
	{ 31, 4, 1},
	{ 64,10, 1},
	{ 65,10, 2},
	{ 68,11, 3},
	{ 69,12, 2},
	{ 71,16, 1},
	{ 80, 9, 1},
	{ 81,12, 1},
	{ 84,11, 1},
	{ 85, 9, 2}, -- 4 vertices
	{ 87, 6, 1},
	{ 92,14, 1},
	{ 93, 7, 2},
	{ 95, 7, 1},
	{112, 3, 3},
	{113,16, 2},
	{116,15, 2},
	{117, 6, 3},
	{119,14, 3},
	{124, 4, 3},
	{125, 7, 3},
	{127,15, 3},
	{193, 2, 2},
	{197,13, 2},
	{199, 2, 1},
	{209,13, 1},
	{213, 5, 2},
	{215, 5, 1},
	{221, 1, 2},
	{223, 1, 1},
	{241, 2, 3},
	{245, 5, 3},
	{247,13, 3},
	{253, 1, 3},
	{255, 6, 2}, -- O-tile
	{256, 3, 2}, -- empty
}


local canvas = love.graphics.newCanvas(emptyTile.w*16, emptyTile.h*3)
love.graphics.setCanvas(canvas)
	local x1, y1 = 0, 0
	love.graphics.setColor(1,1,1)
	for i, spriteTile in ipairs (spriteTiles48) do
		local number = spriteTile[1]
		local x = spriteTile[2]
		local y = spriteTile[3]
		local tile = mapUtiles[number]
		love.graphics.draw(tile.image, (x1+x-1+0.5)*emptyTile.w, (y1+y-1+0.5)*emptyTile.h, tile.r*math.pi/2, 1,1, emptyTile.w/2, emptyTile.h/2)
	end
love.graphics.setCanvas()
local strNumber = string.format("%03d", os.time())
--canvas:newImageData():encode("png","tileset-"..filename..'-'..strNumber..".png")
canvas:newImageData():encode("png","tileset-"..filename..".png")

local mapGrid = {}
local top, bottom = 1, 64
local left, right = 1, 64
local shiftX, shiftY = 0, 0
for y = top, bottom do
	mapGrid[y] = {}
	for x = left, right do
		local value = math.random (4)
		mapGrid[y][x] = (value == 1) and 1 or 0
	end
end

function love.draw()
	love.graphics.translate (shiftX, shiftY)
	
	local x1, y1 = 0, -6
	love.graphics.setColor(1,1,1)
	for i, spriteTile in ipairs (spriteTiles48) do
		local number = spriteTile[1]
		local x = spriteTile[2]
		local y = spriteTile[3]
		local tile = mapUtiles[number]
		love.graphics.setColor(1,1,1)
		love.graphics.draw(tile.image, (x1+x-1+0.5)*emptyTile.w, (y1+y-1+0.5)*emptyTile.h, tile.r*math.pi/2, 1,1, emptyTile.w/2, emptyTile.h/2)
		love.graphics.setColor(0,0,0)
		love.graphics.print (number..' x:'..x..' y:'..y, (x1+x-1+0.5)*emptyTile.w, (y1+y-1+0.5)*emptyTile.h+40)
	end
	
	
	for i, number in ipairs (numbers) do
		local tile = mapUtiles[number]
		local x = i
		local y = -1
		love.graphics.setColor(1,1,1)
		love.graphics.draw(tile.image, (x-1+0.5)*emptyTile.w, (y-1+0.5)*emptyTile.h, tile.r*math.pi/2, 1,1, emptyTile.w/2, emptyTile.h/2)
		
		
		love.graphics.setColor(0,0,0)
		love.graphics.print (number, x*emptyTile.w, y*emptyTile.h)
		love.graphics.print (table.concat(tile.c, ','), x*emptyTile.w, y*emptyTile.h+20)
		love.graphics.print ('r'..tile.r, x*emptyTile.w, y*emptyTile.h+40)
		
	end
	
	love.graphics.scale(0.25)
--	local textColor = {1,1,1} -- white
--	local textColor = {0,0,0,1} -- black
	local textColor = {0,0,0,0} -- transparent
	
	for y = top, bottom do
		for x = left, right do
			
			local value = mapGrid[y][x]
			if value == 1 then
				-- draw full tile
				love.graphics.setColor(1,1,1)
				love.graphics.draw(mapUtiles[0].image, (x-1)*emptyTile.w, (y-1)*emptyTile.h)
				love.graphics.setColor(textColor)
				love.graphics.print (value, (x-1)*emptyTile.w, (y-1)*emptyTile.h)
			elseif false then -- disabled
				love.graphics.setColor(1,1,1)
				love.graphics.rectangle('fill', (x-1)*emptyTile.w, (y-1)*emptyTile.h, emptyTile.w, emptyTile.h)
			else
				local a = mapGrid[y-1] and mapGrid[y-1][x-1] or 1
				local b = mapGrid[y-1] and mapGrid[y-1][x]   or 1
				local c = mapGrid[y-1] and mapGrid[y-1][x+1] or 1
				local d = mapGrid[y]   and mapGrid[y][x+1]   or 1
				local e = mapGrid[y+1] and mapGrid[y+1][x+1] or 1
				local f = mapGrid[y+1] and mapGrid[y+1][x]   or 1
				local g = mapGrid[y+1] and mapGrid[y+1][x-1] or 1
				local h = mapGrid[y]   and mapGrid[y][x-1]   or 1
				if b == 1 then a = 1 c = 1 end
				if d == 1 then c = 1 e = 1 end
				if f == 1 then e = 1 g = 1 end
				if h == 1 then g = 1 a = 1 end
				local number = boolToNum (a, b, c, d, e, f, g, h)
				local tile = mapUtiles[number]
				love.graphics.setColor(1,1,1)
				love.graphics.draw(emptyTile.image, (x-1+0.5)*emptyTile.w, (y-1+0.5)*emptyTile.h, emptyTile.r*math.pi/2, 1,1, emptyTile.w/2, emptyTile.h/2)
				if number == 0 then
					-- nothing to render
--					love.graphics.setColor(1,1,1)
--					love.graphics.rectangle('fill', (x-1)*emptyTile.w, (y-1)*emptyTile.h, emptyTile.w, emptyTile.h)
					
				elseif tile then
					love.graphics.setColor(1,1,1)
					love.graphics.draw(tile.image, (x-1+0.5)*emptyTile.w, (y-1+0.5)*emptyTile.h, tile.r*math.pi/2, 1,1, emptyTile.w/2, emptyTile.h/2)
					love.graphics.setColor(textColor)
					love.graphics.print ('r'..tile.r, (x-1)*emptyTile.w, (y-1)*emptyTile.h+40)
				else
				love.graphics.setColor(1,1,1)
					love.graphics.draw(mapUtiles[0].image, (x-1)*emptyTile.w, (y-1)*emptyTile.h)
				end
				love.graphics.setColor(textColor)
				love.graphics.print (number, (x-1)*emptyTile.w, (y-1)*emptyTile.h)
				love.graphics.print (table.concat({a, b, c, d, e, f, g, h}, ','), (x-1)*emptyTile.w, (y-1)*emptyTile.h+20)
			end
		end
	end
end

function love.mousemoved( x, y, dx, dy, istouch )
	if love.mouse.isDown(1) then
		shiftX, shiftY = shiftX + dx, shiftY + dy
	end
end

function love.keypressed(key, scancode, isrepeat)
	if false then
	elseif key == "escape" then
		love.event.quit()
	end
end

